; Started 32-bit kernel on August 21 2004
[BITS 32]
[ORG 1000h]	; Loaded at 1000h
%define	PIC_MASTER_PORT0	20h
%define	PIC_MASTER_PORT1	21h
%define	PIC_SLAVE_PORT0	0A0h
%define	PIC_SLAVE_PORT1	0A1h

start:
mov bl,07h
call ClearScr
;mov eax,12
;mov ebx,22
;call GoToXY
mov esi,LoadMsg
call PrintPMode

mov al,00010001b		; will send ICW4
out PIC_MASTER_PORT0,al
call Delay32
out PIC_SLAVE_PORT0,al
call Delay32

mov al,20h			; int 20h is base for PIC1
out PIC_MASTER_PORT1,al
call Delay32
mov al,28h			; int 28h is base for PIC2
out PIC_SLAVE_PORT1,al
call Delay32

mov al,00000100b		; IR line 2 is connected to PIC2 (Slave)
out PIC_MASTER_PORT1,al
call Delay32
mov al,00000010b		; IRQ line 2 of PIC1 is connected to PIC2
out PIC_SLAVE_PORT1,al
call Delay32

mov al,01h			; PIC1 is Master
out PIC_MASTER_PORT1,al	
call Delay32
;mov al,01h			; PIC 2 is slave
out PIC_SLAVE_PORT1,al
call Delay32

mov	ecx,1000h
wait_8259:

call	Delay32
dec	ecx
jnz	wait_8259	

mov al,11111100b	; mask all interrupts except the first two (IRQ 0,1 and 2)
out PIC_MASTER_PORT1,al
call Delay32
mov al,0FFh		; mask all ints on PIC 2 ( 0FFh = 11111111b )
out PIC_SLAVE_PORT1,al

call Delay32
mov al,20h
out 64h,al	; Tell keyboard we want to read cmd byte
call Empty8042
in al,60h	; Read in command byte
or al,01h	; set bit 0 (keyboard interrupts enabled)
;or al,03h	; set bit 0 & 1(keyboard & mouse interrupts enabled)

push ax
mov al,60h
out 64h,al	; Tell keyboard we want to write to cmd byte
call Wait_Write_8042
pop ax
out 60h,al	; Write byte to keyboard command byte

;mov ecx,32
;l1:
;mov al,20h
;out 20h,al
;out 0A0h,al
;dec ecx
;jz l2
;jmp l1

;l2:
;xor al,al
;out 80h,al

lidt [idt_desc]
sti
idle: nop
	jmp idle

Keyboard:
	pushad
	pushf
	push ds
	push es
	cli
loop1:
	in al,64h
	and al,01h
	jz loop1
	in al,60h

	mov byte[ds:0B8020h],'K'
;	in al,60h
	mov byte[ds:0B8021h],al

	mov al,20h
	out 20h,al	; Send EOI (End of Interrupt)
	sti

	pop es
	pop ds
	popf
	popad
	iretd
Timer:
	pushad
	push ds
	push es
	inc dword[Ticks]
	mov byte[ds:0B8010h],'R'
	mov eax,[Ticks]
	mov byte[ds:0B8011h],al

	mov al,20h
	out 20h,al	; Send EOI (End of Interrupt)

	pop es
	pop ds
	popad
	iretd

PrintPMode:
	cld
	push ecx
	mov edi,0B8000h
	mov edx,[TextPtr]
	shl edx,1
	add edi,edx
	mov ah,[ds:esi]	; Get text attributes
	inc esi
	strloop:
		mov al,[ds:esi]
		inc esi		; faster than lodsb
		test al,al
		je endstr
		cmp al,13
		je _CR
	put:	mov word [es:edi],ax
		inc dword [TextPtr]
		add edi,2
		jmp strloop
	_CR:
		mov al,[ds:esi]	; get the next character to print
		inc esi
		call PutCR
		jmp put
	endstr:
	mov cx,[TextPtr]
	mov bx,cx		; save it in bx

	mov dx,03D4h
	mov ax,14
	out dx,ax	; out 03D4h,14

	inc dx
	shr bx,8
	mov ax,bx
	out dx,ax	; out 03D5h,(TextPtr >> 8)

	dec dx
	mov ax,15
	out dx,ax	; out 03D4h,15

	inc dx
	mov ax,cx
	out dx,ax	; out 03D5h,TextPtr

	pop ecx
	ret

Empty8042:
	in al, 64h
	test al,1
	jz empty1
	in al, 060h
	jmp Empty8042
	empty1:
	test al,2
	jnz Empty8042
	retn 4

Delay32:		; borrowed from SolarOs
	jmp delay_01
delay_01:
	jmp delay_02
delay_02:
	ret

Wait_Read_8042:
	call Delay32

	in al,064h
	and al,01b
	jnz have_data
	jmp Wait_Read_8042
have_data:
	ret

Wait_Write_8042:
	call Delay32

	in al,64h
	and al,10b
	jnz Wait_Write_8042
	ret

PutChar:
	mov edi,0B8000h
	mov edx,[TextPtr]
	shl edx,1
	add edi,edx
	cmp al,0Dh		; enter
	je short $ + 4
	cmp al,08h		; backspace
	je short $ + 6
	mov word [edi],ax
	inc dword [TextPtr]
	ret
	call PutCR
	ret
	call PutBkSpce
	ret

PutCR:
	push eax	; save all the regs
	push edx
	push ecx
	mov eax,[TextPtr]	; get current VGA CursorPos
	xor edx,edx		; zero edx
	mov ecx,80		; divide the cursur pos by 80
	div ecx		;
	shl edx,1
	add edi,160
	sub edi,edx
	mov eax,edi
	sub eax,0B8000h
	shr eax,1
	mov [TextPtr],eax	; add the remainder to current pos
	pop ecx
	pop edx
	pop eax
	ret

PutBkSpce:
	dec dword[TextPtr]
	sub edi,2

	mov word[edi],0
	ret

GoToXY:	; eax = row, ebx = col, pos = 2*(row*80+col)
	mov ecx,eax	; take another copy in ecx
	shl eax,6	; multiply eax by 64
	shl ecx,4	; multiply ecx by 16
	add eax,ecx	; add both together to get row * 80 as 64 +16 = 80
	add eax,ebx	; add col no.
	inc eax
	mov [TextPtr],eax
	ret

ClearScr:
	cld
	mov edi,0B8000h
	xor ecx,ecx
	mov al," "
	mov ah,bl
	clrloop:
		cmp ecx,2000
		je endcloop
		inc ecx
		mov word [ds:edi],ax
		add edi,2
		jmp clrloop
	endcloop:
	mov dword [TextPtr],0
	ret

%include	"idt.inc"
%include	"keys.inc"

LoadMsg	db 0Eh,"RooOS Kernel is loading......"
		db 0Dh,"Loaded Ok",0

Keymap	db 0,ESCAPE,"1234567890-=",BACKSPACE
		db "	qwertyuiop[]",ENTER,0
		db "asdfghjkl;'`",0,'\'
		db "zxcvbnm,./",0,0,0,' ',0
		db KEY_F1,KEY_F2,KEY_F3,KEY_F4,KEY_F5,KEY_F6,KEY_F7,KEY_F8,KEY_F9,KEY_F10
		db 0,0,KEY_HOME,KEY_UP,KEY_PGUP,'-',KEY_LEFT,'5',KEY_RIGHT,'+',KEY_END,KEY_DOWN
		db KEY_PGDN,KEY_INS,KEY_DEL,0,0,0,KEY_F11,KEY_F12

Keymap_Shift db 0,ESCAPE, '!@#$%^&*()_+' ,BACKSPACE
		db '	QWERTYUIOP{}',ENTER,0
		db 'ASDFGHJKL:"~',0,'|'
		db 'ZXCVBNM<>?',0,0,0,' ',0
		db KEY_F1,KEY_F2,KEY_F3,KEY_F4,KEY_F5,KEY_F6,KEY_F7,KEY_F8,KEY_F9,KEY_F10
		db 0,0,KEY_HOME,KEY_UP,KEY_PGUP,'-',KEY_LEFT,'5',KEY_RIGHT,'+',KEY_END,KEY_DOWN
		db KEY_PGDN,KEY_INS,KEY_DEL,0,0,0,KEY_F11,KEY_F12

Shift		db 0
TextPtr	dd 0
Ticks		dd 0